import type { TableStringField } from '../../table/types';
import { TableColumnTextBase } from '../text-base';
import { TableColumnSortOperation } from '../base/types';
import type { ColumnInternalsOptions } from '../base/models/column-internals';
import type { TableColumnTextBaseColumnConfig } from '../text-base/cell-view';
import { TableColumnTextValidator } from './models/table-column-text-validator';
export type TableColumnTextCellRecord = TableStringField<'value'>;
export interface TableColumnTextColumnConfig extends TableColumnTextBaseColumnConfig {
}
declare global {
    interface HTMLElementTagNameMap {
        'nimble-table-column-text': TableColumnText;
    }
}
declare const TableColumnText_base: (abstract new (...args: any[]) => {
    sortByFieldName?: string;
    customSortOrderColumnNotifier?: import("@ni/fast-element").Notifier;
    customSortOrderColumnChangeHandler: {
        handleChange: (_source: unknown, args: unknown) => void;
    };
    getResolvedOperandDataRecordFieldName(initialOperandFieldName: string | undefined): string | undefined;
    getResolvedSortOperation(initialSortOperation: TableColumnSortOperation): TableColumnSortOperation;
    sortByFieldNameChanged(): void;
    handleSortConfigurationChange(): void;
    handleCustomSortOrderColumnChange(_source: unknown, args: unknown): void;
    updateCustomColumnSortingValidity(): void;
    readonly columnInternals: import("../base/models/column-internals").ColumnInternals<unknown, import("../base/models/column-validator").ColumnValidator<["invalidCustomSortWithGrouping"]>>;
}) & (abstract new (...args: any[]) => {
    groupingDisabled: boolean;
    groupIndex?: number | null;
    groupingDisabledChanged(): void;
    groupIndexChanged(): void;
    readonly columnInternals: import("../base/models/column-internals").ColumnInternals<unknown, import("../base/models/column-validator").ColumnValidator<[]>>;
}) & (abstract new (...args: any[]) => {
    fractionalWidth?: number | null;
    minPixelWidth?: number | null;
    fractionalWidthChanged(): void;
    minPixelWidthChanged(): void;
    readonly columnInternals: import("../base/models/column-internals").ColumnInternals<unknown, import("../base/models/column-validator").ColumnValidator<[]>>;
}) & (abstract new (...args: any[]) => {
    placeholder?: string;
    placeholderChanged(): void;
}) & (abstract new (...args: any[]) => {
    sortingDisabled: boolean;
    sortIndex?: number | null;
    sortDirection: import("../../table/types").TableColumnSortDirection;
    sortingDisabledChanged(): void;
    sortDirectionChanged(): void;
    sortIndexChanged(): void;
    readonly columnInternals: import("../base/models/column-internals").ColumnInternals<unknown, import("../base/models/column-validator").ColumnValidator<[]>>;
}) & ((abstract new () => TableColumnTextBase<TableColumnTextColumnConfig, TableColumnTextValidator>) & {
    compose<T extends import("@ni/fast-foundation").FoundationElementDefinition = import("@ni/fast-foundation").FoundationElementDefinition, K extends import("@ni/fast-element").Constructable<import("@ni/fast-foundation").FoundationElement> = import("@ni/fast-element").Constructable<import("@ni/fast-foundation").FoundationElement>>(this: K, elementDefinition: T): (overrideDefinition?: import("@ni/fast-foundation").OverrideFoundationElementDefinition<T>) => import("@ni/fast-foundation").FoundationElementRegistry<T, K>;
    from<TBase extends {
        new (): HTMLElement;
        prototype: HTMLElement;
    }>(BaseType: TBase): new () => InstanceType<TBase> & import("@ni/fast-element").FASTElement;
    define<TType extends Function>(type: TType, nameOrDef?: string | import("@ni/fast-element").PartialFASTElementDefinition): TType;
});
/**
 * The table column for displaying string fields as text.
 */
export declare class TableColumnText extends TableColumnText_base {
    private readonly defaultSortOperation;
    placeholderChanged(): void;
    handleSortConfigurationChange(): void;
    protected getColumnInternalsOptions(): ColumnInternalsOptions<TableColumnTextValidator>;
    protected fieldNameChanged(): void;
    private updateColumnInternalsSortConfiguration;
}
export declare const tableColumnTextTag = "nimble-table-column-text";
export {};
